(ns wanijo.domain.schema
  (:require [clojurewerkz.neocons.rest.cypher :as cypher]
            [clojure.spec.alpha :as spec]
            [wanijo.neo4j :as neo4j]
            [wanijo.devmode :as devmode]))

(spec/def ::name
  (spec/and string? not-empty int?))

(spec/def ::created-at
  (spec/or :int (spec/and int?
                          #(> % 20000101000000))
           :str (spec/and string?
                          #(re-matches #"\d{4}\d{2}\d{2}\d{2}\d{2}\d{2}" %))))

(defn all-created-by! [ident]
  (neo4j/query-rawdata!
   :query
   "MATCH (s:schema)-[:created_by]->(u:user)
    WHERE u.ident = {ident}
    RETURN s
    ORDER BY s.name"
   :params {:ident ident}
   :alias "s"
   ))
